/***************************************************************************
 *            main.c
 *
 *  Fri Jul 23 11:43:41 2004
 *  Copyright  2004  benjie
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "tocdoc.h"
#include "timeline.h"
#include "inspector.h"
#include "audio.h"

#ifdef WIN32
#include <windows.h>
#include <shlwapi.h>
gchar *daoismDir;
#endif

tlType       *tl = NULL;
GtkStatusbar *statusBar;
guint        statusBarID;
prefsStruct  prefs;


int main (int argc, char *argv[])
{
    GtkWidget *mainWin;
    tocDoc    *doc = NULL;
    gchar     *pixmapsDir;
    gint      i;
    gint      length;
#ifdef WIN32
    TCHAR     modulePath[PATH_MAX];
#endif
    
#ifdef ENABLE_NLS
    bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
    bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
    textdomain (GETTEXT_PACKAGE);
#endif

    gtk_set_locale();
    gtk_init(&argc, &argv);
    g_thread_init(NULL);
    
#ifdef WIN32
    GetModuleFileName(NULL, modulePath, PATH_MAX);
    PathRemoveFileSpec(modulePath);
    daoismDir = g_locale_to_utf8(modulePath, -1, NULL, NULL, NULL);
    pixmapsDir = g_strdup_printf("%s\\pixmaps", daoismDir);
    add_pixmap_directory(pixmapsDir);
    g_free(pixmapsDir);
#else
    add_pixmap_directory(PACKAGE_DATA_DIR "/pixmaps/" PACKAGE);
#endif

    openPrefs();
    
    mainWin = create_main();

    if (argc == 1) {
        if (!doc) doc = newTocDoc();
    } else {
        length = getFileLength(argv[1]);
        if (length == teNotSound) {
            doc = openTocDoc(argv[1]);
        }
        if (!doc) {
            doc = newTocDoc();
            for (i = 1; i < argc; i++) {
                length = getFileLength(argv[1]);
                if (length > 0) {
                    tocDocAppendEntry(doc, tocDocNewEntry(doc, argv[i], 0, 
                        ((prefs.autoPregap) ? 2*FRAMES_PER_SEC : 0), -1, TRUE));
                    doc->dirty = TRUE;
                }
            }
        }
    }
    
    statusBar = (GtkStatusbar *)lookup_widget(mainWin, "status");
    statusBarID = gtk_statusbar_get_context_id(statusBar, "timeline");
    tlCreate(&tl, lookup_widget(mainWin, "timeline"), (GtkRange *)lookup_widget(mainWin, "scroller"), doc);

    updateInspector();
    tlSetScroller(tl, 0);

    gtk_widget_show(mainWin);

    gtk_main();
    
    return 0;
}
